#include <mpi.h>
#include <stdio.h>
#include <string.h>
 
#define SERVER 0
#define TAG 2

int main(int argc, char **argv) {

	int my_rank, world_size; 
	int destination=SERVER, source;
	int tag=TAG, length;
	char message[256], name[80];
	MPI_Status status;

	MPI_Init(&argc, &argv); 

	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &world_size);
	MPI_Get_processor_name(name, &length);

	sprintf(message, "Process %d (%d of %d) on %s!", 
			my_rank, my_rank+1, world_size, name);

	if (my_rank != SERVER) { // Client Section
		fprintf(stderr, "Client: process %d\n", my_rank);
		MPI_Send(message,     strlen(message)+1, MPI_CHAR,
			     destination, tag,               MPI_COMM_WORLD);
	} else { // Server Section
		fprintf(stderr, "Server: process %d\n",  my_rank);

		fprintf(stderr, "%s\n", message);
		for (source = 1; source < world_size ; source++) {
			MPI_Recv(message, 256, MPI_CHAR,
			         source,  tag, MPI_COMM_WORLD, 
			         &status);
			fprintf(stderr, "%s\n", message);
		}
	}

	fprintf(stderr, "Calling Finalize %d\n",my_rank);
	MPI_Finalize();
} 
